_, class = UnitClass("player")
if class == "MONK" then

local ADDON_NAME, namespace = ...
local L = namespace.L

MHClassColor = {
DEATHKNIGHT = "ffc41f3b",
DRUID = "ffff7d0a",
HUNTER = "ffabd473",
MAGE = "ff69ccf0",
MONK = "ff00ff96",
PALADIN = "fff58cba",
PRIEST = "ffffffff",
ROGUE = "fffff569",
SHAMAN = "ff0070de",
WARLOCK = "ff9482c9",
WARRIOR = "ffc79c6e",
}

function MonkHelper_PlaceCastingBar()
CastingBarFrame:ClearAllPoints()
CastingBarFrame:SetParent(CastingBarFrameDrag)
CastingBarFrame:SetPoint("CENTER")
CastingBarFrame:SetMovable(true)
CastingBarFrame:SetParent(UIParent)
CastingBarFrame:SetMovable(false)
end

function MonkHelper_CreateCastingBarFrameMover()
UIPARENT_MANAGED_FRAME_POSITIONS["CastingBarFrame"] = nil
---------------------------------------------------
local dragframe = CreateFrame("Frame", "CastingBarFrameDrag", UIParent)
local relativepoint, _, relativeto, xoff, yoff = CastingBarFrame:GetPoint()
dragframe:SetWidth(200)
dragframe:SetHeight(18)
dragframe:SetPoint(relativepoint, UIParent, relativeto, xoff, yoff)
dragframe:SetFrameStrata("MEDIUM")
CastingBarFrame:ClearAllPoints()
CastingBarFrame:SetParent(dragframe)
CastingBarFrame:SetPoint("CENTER")
dragframe:SetScript("OnDragStart", function(self)
CastingBarFrame:ClearAllPoints()
CastingBarFrame:SetParent(CastingBarFrameDrag)
CastingBarFrame:SetPoint("CENTER")
CastingBarFrame:SetMovable(true)
self:StartMoving()
end)
dragframe:SetScript("OnDragStop", function(self)
CastingBarFrame:SetParent(UIParent)
CastingBarFrame:SetMovable(false)
local point, relativeto, relativepoint, xoff, yoff = dragframe:GetPoint()
MonkHelper_Profiles[MonkHelper_ActiveProfile].options[self:GetName()] = {point, relativeto, relativepoint, xoff, yoff}
self:StopMovingOrSizing()
end)
dragframe:RegisterForDrag("LeftButton")
dragframe:EnableMouse(true)
dragframe:SetMovable(true)
----------------------------------------------------
CastingBarFrameDrag:SetScript("OnUpdate", function(self, elapsed)
MHcastingbarframedelay = MHcastingbarframedelay - elapsed
if MHcastingbarframedelay <= 0 then
MHcastingbarframedelay = 0
CastingBarFrameDrag:Hide()
CastingBarFrameDrag:StopMovingOrSizing()
end
end)
CastingBarFrameDrag:CreateTexture("$parentBackground")
CastingBarFrameDragBackground:SetWidth(CastingBarFrameDrag:GetWidth())
CastingBarFrameDragBackground:SetHeight(CastingBarFrameDrag:GetHeight())
CastingBarFrameDragBackground:SetAllPoints()
CastingBarFrameDragBackground:SetTexture(0, 0, 1)
CastingBarFrameDrag:CreateFontString("$parentText", "OVERLAY", "GameFontNormal")
CastingBarFrameDragText:SetPoint("CENTER")
CastingBarFrameDragText:SetText(L["CASTING_BAR_FRAME_MOVER"])
CastingBarFrameDrag:Hide()

end

function MonkHelper_CreateTimer(name, point, rframe, rpoint, xoff, yoff)
local frame, icon, text, bg, bar, bartext, cd
frame = CreateFrame("Frame", name, UIParent)
frame:SetHeight(31.5)
frame:SetWidth(126)
frame:SetPoint(point, rframe, rpoint, xoff, yoff)
icon = frame:CreateTexture("$parentIcon")
icon:SetWidth(28)
icon:SetHeight(28)
icon:SetPoint("LEFT", frame, "LEFT", 1.5, 0)
cd = CreateFrame("Cooldown", "$parentCooldown" , frame, "CooldownFrameTemplate")
cd:ClearAllPoints()
cd:SetWidth(28)
cd:SetHeight(28)
cd:SetPoint("CENTER", icon, "CENTER")
cd:SetReverse(true)
text = frame:CreateFontString("$parentText", "OVERLAY", "GameFontNormal")
text:SetWidth(frame:GetWidth() - icon:GetWidth() - 6)
text:SetHeight(7)
text:SetTextHeight(10)
bg = frame:CreateTexture("$parentBG", "BACKGROUND")
bg:SetAllPoints()
bg:SetTexture(0, 0, 0, 0.8)
bar = CreateFrame("StatusBar", "$parentBar", frame)
bar:SetWidth(bg:GetWidth() - icon:GetWidth() - 2)
bar:SetHeight(10)
bar:SetPoint("BOTTOMLEFT", icon, "BOTTOMRIGHT", 0, 1)
text:SetPoint("BOTTOMLEFT", bar, "TOPLEFT", 0, 7)
bar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
bar:SetStatusBarColor(0, 1, 0.6)
bar:SetMinMaxValues(0, 1)
bar:SetValue(0)
bartext = bar:CreateFontString("$parentText", "OVERLAY", "GameFontNormal")
bartext:SetPoint("CENTER", bar, "CENTER", 0, -0.5)
bartext:SetTextColor(1, 1, 1)
bartext:SetTextHeight(11)
MonkHelper_SetupFrame(frame)
frame:Hide()
count = frame:CreateFontString("$parentCount", "OVERLAY", "NumberFontNormal")
count:SetTextColor(1, 1, 1)
count:SetTextHeight(16)
count:SetPoint("BOTTOMRIGHT", icon, "BOTTOMRIGHT")

end
-- Just Saves Me Some Typing =) --
function MonkHelper_SetupFrame(frame) -- My baby. it creates drag frames under the main frame so that when you change the scale, the frame doesnt move around the screen. Also saves positions.
dragframe = CreateFrame("Frame", frame:GetName().."Drag", UIParent)
local relativepoint, _, relativeto, xoff, yoff = frame:GetPoint()
dragframe:SetWidth(frame:GetWidth())
dragframe:SetHeight(frame:GetHeight())
dragframe:SetPoint(relativepoint, UIParent, relativeto, xoff, yoff)
dragframe:SetFrameStrata("MEDIUM")
dragframe:SetToplevel()
frame:ClearAllPoints()
frame:SetParent(dragframe)
frame:SetPoint("CENTER")
frame:SetScript("OnDragStart", function(self)
self:GetParent():StartMoving()
end)
frame:SetScript("OnDragStop", function(self)
local point, relativeto, relativepoint, xoff, yoff = _G[self:GetName().."Drag"]:GetPoint()
MonkHelper_Profiles[MonkHelper_ActiveProfile].options[self:GetName().."Drag"] = {point, relativeto, relativepoint, xoff, yoff}
self:GetParent():StopMovingOrSizing()
end)
frame:RegisterForDrag("LeftButton")
frame:EnableMouse(true)
dragframe:SetMovable(true)
end

function MonkHelper_LockFrames()
if UnitAffectingCombat("player") == false then

end
MHTouchOfDeathNotification:EnableMouse(false)
MHTouchOfDeathNotificationDrag:StopMovingOrSizing()
MHStaggerTracker:EnableMouse(false)
MHStaggerTrackerDrag:StopMovingOrSizing()
MHChiBar:EnableMouse(false)
MHChiBarDrag:StopMovingOrSizing()
MHResourceBar:EnableMouse(false)
MHResourceBarDrag:StopMovingOrSizing()
MHTigereyeBrewTimer:EnableMouse(false)
MHTigereyeBrewTimerDrag:StopMovingOrSizing()
MHElusiveBrewTimer:EnableMouse(false)
MHElusiveBrewTimerDrag:StopMovingOrSizing()
MHManaTeaTimer:EnableMouse(false)
MHManaTeaTimerDrag:StopMovingOrSizing()
MHParalysisMonitor:EnableMouse(false)
MHParalysisMonitorDrag:StopMovingOrSizing()
MHParalysisTimer:EnableMouse(false)
MHParalysisTimerDrag:StopMovingOrSizing()
MHXuenTimer:EnableMouse(false)
MHXuenTimerDrag:StopMovingOrSizing()
MHRisingSunKickTimer:EnableMouse(false)
MHRisingSunKickTimerDrag:StopMovingOrSizing()
MHTouchOfKarmaTimer:EnableMouse(false)
MHTouchOfKarmaTimerDrag:StopMovingOrSizing()
MHEnergizingBrewTimer:EnableMouse(false)
MHEnergizingBrewTimerDrag:StopMovingOrSizing()
MHTigerPowerTimer:EnableMouse(false)
MHTigerPowerTimerDrag:StopMovingOrSizing()
MHFlyingSerpentKickTimer:EnableMouse(false)
MHFlyingSerpentKickTimerDrag:StopMovingOrSizing()
MHRenewingMistTimer:EnableMouse(false)
MHRenewingMistTimerDrag:StopMovingOrSizing()
MHKegSmashTimer:EnableMouse(false)
MHKegSmashTimerDrag:StopMovingOrSizing()
MHThunderFocusTeaTimer:EnableMouse(false)
MHThunderFocusTeaTimerDrag:StopMovingOrSizing()
MHSerpentsZealTimer:EnableMouse(false)
MHSerpentsZealTimerDrag:StopMovingOrSizing()
MHFistsOfFuryTimer:EnableMouse(false)
MHFistsOfFuryTimerDrag:StopMovingOrSizing()
MHGuardTimer:EnableMouse(false)
MHGuardTimerDrag:StopMovingOrSizing()
MHShuffleTimer:EnableMouse(false)
MHShuffleTimerDrag:StopMovingOrSizing()
MHExpelHarmTimer:EnableMouse(false)
MHExpelHarmTimerDrag:StopMovingOrSizing()
MHTigersLustTimer:EnableMouse(false)
MHTigersLustTimerDrag:StopMovingOrSizing()
MHChiBrewTimer:EnableMouse(false)
MHChiBrewTimerDrag:StopMovingOrSizing()
MHRingOfPeaceTimer:EnableMouse(false)
MHRingOfPeaceTimerDrag:StopMovingOrSizing()
MHDiffuseMagicTimer:EnableMouse(false)
MHDiffuseMagicTimerDrag:StopMovingOrSizing()
MHDetoxTimer:EnableMouse(false)
MHDetoxTimerDrag:StopMovingOrSizing()
MHRollTimer:EnableMouse(false)
MHRollTimerDrag:StopMovingOrSizing()
MHProvokeTimer:EnableMouse(false)
MHProvokeTimerDrag:StopMovingOrSizing()
MHSpearHandStrikeTimer:EnableMouse(false)
MHSpearHandStrikeTimerDrag:StopMovingOrSizing()
MHZenMeditationTimer:EnableMouse(false)
MHZenMeditationTimerDrag:StopMovingOrSizing()
MHTranscendenceTimer:EnableMouse(false)
MHTranscendenceTimerDrag:StopMovingOrSizing()
MHTranscendenceTransferTimer:EnableMouse(false)
MHTranscendenceTransferTimerDrag:StopMovingOrSizing()
MHVitalMistsTimer:EnableMouse(false)
MHVitalMistsTimerDrag:StopMovingOrSizing()
MHBlackoutKickTimer:EnableMouse(false)
MHBlackoutKickTimerDrag:StopMovingOrSizing()
MHTigerPalmTimer:EnableMouse(false)
MHTigerPalmTimerDrag:StopMovingOrSizing()

end

function MonkHelper_UnlockFrames(bypass)
local value

if bypass then
value = true
elseif MonkHelper_Profiles[MonkHelper_ActiveProfile].options.lockframes == false then
value = true
elseif MonkHelper_Profiles[MonkHelper_ActiveProfile].options.lockframes == true then
value = false
end
if UnitAffectingCombat("player") == false then

end
MHTouchOfDeathNotification:EnableMouse(value)
MHStaggerTracker:EnableMouse(value)
MHChiBar:EnableMouse(value)
MHResourceBar:EnableMouse(value)
MHTigereyeBrewTimer:EnableMouse(value)
MHElusiveBrewTimer:EnableMouse(value)
MHManaTeaTimer:EnableMouse(value)
MHParalysisTimer:EnableMouse(value)
MHParalysisMonitor:EnableMouse(value)
MHXuenTimer:EnableMouse(value)
MHRisingSunKickTimer:EnableMouse(value)
MHEnergizingBrewTimer:EnableMouse(value)
MHTigerPowerTimer:EnableMouse(value)
MHFlyingSerpentKickTimer:EnableMouse(value)
MHRenewingMistTimer:EnableMouse(value)
MHKegSmashTimer:EnableMouse(value)
MHThunderFocusTeaTimer:EnableMouse(value)
MHSerpentsZealTimer:EnableMouse(value)
MHFistsOfFuryTimer:EnableMouse(value)
MHGuardTimer:EnableMouse(value)
MHShuffleTimer:EnableMouse(value)
MHExpelHarmTimer:EnableMouse(value)
MHTigersLustTimer:EnableMouse(value)
MHChiBrewTimer:EnableMouse(value)
MHRingOfPeaceTimer:EnableMouse(value)
MHDiffuseMagicTimer:EnableMouse(value)
MHDetoxTimer:EnableMouse(value)
MHRollTimer:EnableMouse(value)
MHProvokeTimer:EnableMouse(value)
MHSpearHandStrikeTimer:EnableMouse(value)
MHZenMeditationTimer:EnableMouse(value)
MHTranscendenceTimer:EnableMouse(value)
MHTranscendenceTransferTimer:EnableMouse(value)
MHVitalMistsTimer:EnableMouse(value)
MHBlackoutKickTimer:EnableMouse(value)
MHTigerPalmTimer:EnableMouse(value)
end

function MonkHelper_Show(frame, value)
if value == true then
frame:Show()
else
frame:Hide()
end
end

function MonkHelper_ShowFrames()
MHtimerbypass = 60
MHparalysisdelay, MHparalysisduration, MHnewparalysisguid, MHparalysisguid, MHparalysisname, MHparalysisapplied, MHparalysisbroken = 0, 0, nil, nil, nil, false, false
MHparalysisculprit, MHparalysisspell, MHparalysisculpritspell, MHparalysisremove, MHparalysisbrokenevent = nil, nil, nil, false, nil
MHParalysisMonitorBar:SetMinMaxValues(0, 60)
MHParalysisMonitorText:SetText(L["PARALYSIS"].." "..L["MONITOR"])
MHParalysisMonitor:Show()
MonkHelper_UnlockFrames(true)

MHTouchOfDeathNotification:Show()
MHStaggerTracker:Show()
MHChiBar:Show()
MHResourceBar:Show()
MonkHelper_NewTime("MHTigereyeBrewTimer", 60, true)
MHTigereyeBrewTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHElusiveBrewTimer", 60, true)
MHElusiveBrewTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHManaTeaTimer", 60, true)
MHManaTeaTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHParalysisTimer", 60, true)
MHParalysisTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHXuenTimer", 60, true)
MHXuenTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHRisingSunKickTimer", 60, true)
MHRisingSunKickTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHTouchOfKarmaTimer", 60, true)
MHTouchOfKarmaTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHEnergizingBrewTimer", 60, true)
MHEnergizingBrewTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHTigerPowerTimer", 60, true)
MHTigerPowerTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHFlyingSerpentKickTimer", 60, true)
MHFlyingSerpentKickTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHRenewingMistTimer", 60, true)
MHRenewingMistTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHKegSmashTimer", 60, true)
MHKegSmashTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHThunderFocusTeaTimer", 60, true)
MHThunderFocusTeaTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHSerpentsZealTimer", 60, true)
MHSerpentsZealTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHFistsOfFuryTimer", 60, true)
MHFistsOfFuryTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHGuardTimer", 60, true)
MHGuardTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHShuffleTimer", 60, true)
MHShuffleTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHExpelHarmTimer", 60, true)
MHExpelHarmTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHTigersLustTimer", 60, true)
MHTigersLustTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHChiBrewTimer", 60, true)
MHChiBrewTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHRingOfPeaceTimer", 60, true)
MHRingOfPeaceTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHDiffuseMagicTimer", 60, true)
MHDiffuseMagicTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHDetoxTimer", 60, true)
MHDetoxTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHRollTimer", 60, true)
MHRollTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHProvokeTimer", 60, true)
MHProvokeTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHSpearHandStrikeTimer", 60, true)
MHSpearHandStrikeTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHZenMeditationTimer", 60, true)
MHZenMeditationTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHTranscendenceTimer", 60, true)
MHTranscendenceTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHTranscendenceTransferTimer", 60, true)
MHTranscendenceTransferTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHVitalMistsTimer", 60, true)
MHVitalMistsTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHBlackoutKickTimer", 60, true)
MHBlackoutKickTimerBar:SetMinMaxValues(0, 60)
MonkHelper_NewTime("MHTigerPalmTimer", 60, true)
MHTigerPalmTimerBar:SetMinMaxValues(0, 60)
MHDetoxTracker:Show()
MHDetoxTrackerHeader:Show()


end

function MonkHelper_ReloadUI()
MHReloadUI:Show()
end

function MonkHelper_HideFrames()
if UnitAffectingCombat("player") == false then
MHDetoxTracker:Hide()
end
MHTouchOfDeathNotification:Hide()
MHStaggerTracker:Hide()
MHChiBar:Hide()
MHResourceBar:Hide()
MHTigereyeBrewTimer:Hide()
MHElusiveBrewTimer:Hide()
MHManaTeaTimer:Hide()
MHTigerPowerTimer:Hide()
MHFlyingSerpentKickTimer:Hide()
MHRisingSunKickTimer:Hide()
MHRenewingMistTimer:Hide()
MHKegSmashTimer:Hide()
MHFistsOfFuryTimer:Hide()
MHGuardTimer:Hide()
MHChiBrewTimer:Hide()
MHDetoxTimer:Hide()
MHRollTimer:Hide()
MHTranscendenceTimer:Hide()
MHTranscendenceTransferTimer:Hide()
MHTigersLustTimer:Hide()
MHProvokeTimer:Hide()
MHSpearHandStrikeTimer:Hide()
MHExpelHarmTimer:Hide()
MHEnergizingBrewTimer:Hide()
MHThunderFocusTeaTimer:Hide()
MHParalysisTimer:Hide()
MHShuffleTimer:Hide()
MHChiBar:Hide()
end

function MonkHelper_UpdateUI(regen)
if MonkHelper_Profiles[MonkHelper_ActiveProfile].options.lockframes == true then
MonkHelper_LockFrames()
else
MonkHelper_UnlockFrames()
end
MonkHelper_HideFrames()

-- hide manually because events wont fire for these frames if they are hidden, which makes less work for the computer.
if MonkHelper_Profiles[MonkHelper_ActiveProfile].options.enableparalysismonitor == false then
MHParalysisMonitor:Hide()
end

if MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhminimapbutton == true then
LibStub("LibDBIcon-1.0"):Show("MonkHelper")
else
LibStub("LibDBIcon-1.0"):Hide("MonkHelper")
end

if MHSpec == "Brewmaster" then
MonkHelper_Show(MHElusiveBrewTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhelusivebrewtimer)
MonkHelper_Show(MHKegSmashTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhkegsmashtimer)
MonkHelper_Show(MHGuardTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhguardtimer)
MonkHelper_Show(MHShuffleTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhshuffletimer)
MonkHelper_Show(MHStaggerTracker, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhstaggertracker)

elseif MHSpec == "Mistweaver" then
MonkHelper_Show(MHManaTeaTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhmanateatimer)
MonkHelper_Show(MHRenewingMistTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhrenewingmisttimer)
MonkHelper_Show(MHThunderFocusTeaTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhthunderfocusteatimer)
MonkHelper_Show(MHRisingSunKickTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhrisingsunkicktimer)

elseif MHSpec == "Windwalker" then
MonkHelper_Show(MHTigereyeBrewTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhtigereyebrewtimer)
MonkHelper_Show(MHFlyingSerpentKickTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhflyingserpentkicktimer)
MonkHelper_Show(MHFistsOfFuryTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhfistsoffurytimer)
MonkHelper_Show(MHEnergizingBrewTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhenergizingbrewtimer)
MonkHelper_Show(MHRisingSunKickTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhrisingsunkicktimer)

end

if UnitAffectingCombat("player") == false then
MonkHelper_Show(MHDetoxTracker, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhdetoxtracker)
else
MHsetdetoxtracker = true
end

MonkHelper_Show(MHProvokeTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhprovoketimer)
MonkHelper_Show(MHTigerPowerTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhtigerpowertimer)
MonkHelper_Show(MHChiBrewTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhchibrewtimer)
MonkHelper_Show(MHDetoxTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhdetoxtimer)
MonkHelper_Show(MHRollTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhrolltimer)
MonkHelper_Show(MHTranscendenceTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhtranscendencetimer)
MonkHelper_Show(MHTranscendenceTransferTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhtranscendencetransfertimer)
MonkHelper_Show(MHTigersLustTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhtigerslusttimer)
MonkHelper_Show(MHSpearHandStrikeTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhspearhandstriketimer)
MonkHelper_Show(MHExpelHarmTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhexpelharmtimer)
MonkHelper_Show(MHParalysisTimer, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhparalysistimer)
MonkHelper_Show(MHChiBar, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhchibar)
MonkHelper_Show(MHChiBarBackground, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhchibarbackground)
MonkHelper_Show(MHResourceBar, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.enableresourcebar)
MonkHelper_Show(MHHealthBar, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.enablehealthbar)
MonkHelper_Show(MHResourceBarReserve, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhresourcebarreserve)
MonkHelper_Show(MHResourceBarMarker1, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhresourcebarmarker1)
MonkHelper_Show(MHResourceBarMarker2, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhresourcebarmarker2)
MonkHelper_Show(MHResourceBarMarker3, MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhresourcebarmarker3)

if MonkHelper_Profiles[MonkHelper_ActiveProfile].options.show.mhtouchofdeathnotification == true then
local expire, cd = GetSpellCooldown(MHSpellID["MHTouchOfDeathTimer"])
if cd == nil then cd = 0 end
if expire == nil then expire = 0 end
if UnitIsPlayer("target") == true and UnitReaction("player", "target") ~= nil then
if cd <= 1 and ((UnitHealth("target") / UnitHealthMax("target")) <= 0.1) and UnitHealth("target") > 0 and UnitReaction("player", "target") <= 4 and IsUsableSpell(MHSpellID["MHTouchOfDeathTimer"]) == true then
MHTouchOfDeathNotification:Show()
else
MHTouchOfDeathNotification:Hide()
end
elseif UnitIsPlayer("target") == false and UnitReaction("player", "target") ~= nil then
if cd <= 1 and UnitHealth("target") < UnitHealthMax("player") and UnitHealth("target") > 0 and UnitReaction("player", "target") <= 4 and IsUsableSpell(MHSpellID["MHTouchOfDeathTimer"]) == true then 
MHTouchOfDeathNotification:Show()
else
MHTouchOfDeathNotification:Hide()
end
else
MHTouchOfDeathNotification:Hide()
end
else
MHTouchOfDeathNotification:Hide()
end

MonkHelper_ResourceBarMarkersUpdate()

if regen == true then
MonkHelper_HideFrames()
else
return
end

end

function MonkHelper_PlaceFrames()

MonkHelper_SetPoint(MHStaggerTrackerDrag)
MonkHelper_SetPoint(MHChiBarDrag)
MonkHelper_SetPoint(MHResourceBarDrag)
MonkHelper_SetPoint(MHTigereyeBrewTimerDrag)
MonkHelper_SetPoint(MHElusiveBrewTimerDrag)
MonkHelper_SetPoint(MHManaTeaTimerDrag)
MonkHelper_SetPoint(MHParalysisTimerDrag)
MonkHelper_SetPoint(MHXuenTimerDrag)
MonkHelper_SetPoint(MHRisingSunKickTimerDrag)
MonkHelper_SetPoint(MHTouchOfKarmaTimerDrag)
MonkHelper_SetPoint(MHEnergizingBrewTimerDrag)
MonkHelper_SetPoint(MHTigerPowerTimerDrag)
MonkHelper_SetPoint(MHFlyingSerpentKickTimerDrag)
MonkHelper_SetPoint(MHRenewingMistTimerDrag)
MonkHelper_SetPoint(MHKegSmashTimerDrag)
MonkHelper_SetPoint(MHThunderFocusTeaTimerDrag)
MonkHelper_SetPoint(MHSerpentsZealTimerDrag)
MonkHelper_SetPoint(MHFistsOfFuryTimerDrag)
MonkHelper_SetPoint(MHGuardTimerDrag)
MonkHelper_SetPoint(MHShuffleTimerDrag)
MonkHelper_SetPoint(MHExpelHarmTimerDrag)
MonkHelper_SetPoint(MHTigersLustTimerDrag)
MonkHelper_SetPoint(MHChiBrewTimerDrag)
MonkHelper_SetPoint(MHRingOfPeaceTimerDrag)
MonkHelper_SetPoint(MHDiffuseMagicTimerDrag)
MonkHelper_SetPoint(MHDetoxTimerDrag)
MonkHelper_SetPoint(MHRollTimerDrag)
MonkHelper_SetPoint(MHProvokeTimerDrag)
MonkHelper_SetPoint(MHSpearHandStrikeTimerDrag)
MonkHelper_SetPoint(MHZenMeditationTimerDrag)
MonkHelper_SetPoint(MHTranscendenceTimerDrag)
MonkHelper_SetPoint(MHTranscendenceTransferTimerDrag)
MonkHelper_SetPoint(MHVitalMistsTimerDrag)
MonkHelper_SetPoint(MHBlackoutKickTimerDrag)
MonkHelper_SetPoint(MHTigerPalmTimerDrag)
MonkHelper_SetPoint(MHTouchOfDeathNotificationDrag)

MonkHelper_SetPoint(MHParalysisMonitorDrag)
CastingBarFrame:SetParent(CastingBarFrameDrag)
MonkHelper_SetPoint(CastingBarFrameDrag)
CastingBarFrame:SetParent(UIParent)

if UnitAffectingCombat("player") == false then
MonkHelper_SetPoint(MHDetoxTrackerDrag)
else
MHplacedetoxtracker = true
end

end

function MonkHelper_SetPoint(self)
self:ClearAllPoints()
self:SetPoint(MonkHelper_Profiles[MonkHelper_ActiveProfile].options[self:GetName()][1], MonkHelper_Profiles[MonkHelper_ActiveProfile].options[self:GetName()][2], MonkHelper_Profiles[MonkHelper_ActiveProfile].options[self:GetName()][3], MonkHelper_Profiles[MonkHelper_ActiveProfile].options[self:GetName()][4], MonkHelper_Profiles[MonkHelper_ActiveProfile].options[self:GetName()][5])
end

function MonkHelper_CreateMiniMapButton()
local dataObject = LibStub("LibDataBroker-1.1"):NewDataObject("MonkHelper", {
     type = "launcher",
     name = "MonkHelper",
     icon = "Interface\\Icons\\ability_monk_chibrew",
     OnClick = function(self, button)
          MHOptionsFrame:SetShown(not MHOptionsFrame:IsShown())
          for idx = 1, MHMenuButtons do
          local frame = _G["MHOptionsFrameButtonsButton"..idx]
          frame.clicked = false
          _G["MHOptionsFrameButtonsButton"..idx.."Highlight"]:Hide()
          _G["MHOptionsFrameButtonsButton"..idx.."Text"]:SetTextColor(1, 0.83, 0)
          frame.parent:Hide()
          end
          MHOptionsFrameButtonsButton1:Click()
          MonkHelper.panel:Show()
          end,
	 OnEnter = function(self)
	 GameTooltip:ClearAllPoints()
	 GameTooltip:SetOwner(self)
	 GameTooltip:SetText("|cff00ff96Monk Helper|r")
	 GameTooltip:Show()
	 end,
	 OnLeave = function(self)
	 GameTooltip:Hide()
	 end,
})

MHMiniMapButton = LibStub("LibDBIcon-1.0"):Register("MonkHelper", dataObject, MonkHelperMiniMap)
end



end
